#ifndef _LINETOSCR_DEFS
   #define _LINETOSCR_DEFS
   
   /* Lines are split into 32-pixel segments.
    * Only changed segments are redrawn.
    */
   #define LINETOSCR_NEXT_PIXEL \
      if (--segment_counter == 0) { \
         if ((changes >>= 1) == 0) \
            break; \
         segment_counter = 32 / SRC_INC; \
         do_redraw = 0; \
      }

   /* Skip unchanged line segment */
   #if HDOUBLE
      #define LINETOSCR_SKIP_SEGMENT \
         spix += 32; \
         dpix += 64 / SRC_INC; \
         if ((changes >>= 1) == 0) \
            break;
   #else
      #define LINETOSCR_SKIP_SEGMENT \
         spix += 32; \
         dpix += 32 / SRC_INC; \
         if ((changes >>= 1) == 0) \
            break;
   #endif
#endif

static int LNAME (int spix, int dpix, int stoppos)
{
   register TYPE *buf = ((TYPE *)xlinebuffer);
#if AGA
   uae_u8 xor_val;
#endif
//   /* Each bit in 'changes' represents 32 Amiga pixels */
//   int invisible_shift_out = xstart >> 5;
//   unsigned int changes = line_changes[active_line] >> invisible_shift_out;
//   /* If data is displayed with pixel offset, initial segment counter
//    * (for the first *visible* segment) is not 32 pixels, but what remains to 32.
//    * Completely invisible segments are skipped with invisible_shift_out.
//    */
//   int segment_counter = (32 - (xstart & 31)) >> (SRC_INC - 1); /* SRC_INC in {1,2} */;
//   /* If pixel offset exists, first segment is always redrawn
//    * (ex: WB3.1 + KS2.0)
//    */
//   int do_redraw = (xstart > 0);

#if AGA
   xor_val = (uae_u8)(dp_for_drawing->bplcon4 >> 8);
#endif
   if (dp_for_drawing->ham_seen) {
      /* HAM 6 / HAM 8 */
      while (dpix < stoppos) {
//         if ((changes & 1) | do_redraw) {
#if AGA
            TYPE d = CONVERT_RGB (ham_linebuf[spix]);
#else
            TYPE d = xcolors[ham_linebuf[spix]];
#endif
            spix += SRC_INC;
            buf[dpix++] = d;
#if HDOUBLE
            buf[dpix++] = d;
#endif
//            LINETOSCR_NEXT_PIXEL
//         } else {
//            LINETOSCR_SKIP_SEGMENT
//         }
      }
   } else if (bpldualpf) {
#if AGA
      /* AGA Dual playfield */
      int *lookup = bpldualpfpri ? dblpf_ind2_aga : dblpf_ind1_aga;
      int *lookup_no = bpldualpfpri ? dblpf_2nd2 : dblpf_2nd1;
      while (dpix < stoppos) {
//         if ((changes & 1) | do_redraw) {
            int pixcol = pixdata.apixels[spix];
            TYPE d;
            if (spriteagadpfpixels[spix]) {
               d = colors_for_drawing.acolors[spriteagadpfpixels[spix]];
               spriteagadpfpixels[spix]=0;
            } else {
               int val = lookup[pixcol];
               if (lookup_no[pixcol] == 2)  val += dblpfofs[bpldualpf2of];
               /* val ^= xor; ??? */
               d = colors_for_drawing.acolors[val];
            }
            spix += SRC_INC;
            buf[dpix++] = d;
#if HDOUBLE
            buf[dpix++] = d;
#endif
//            LINETOSCR_NEXT_PIXEL
//         } else {
//            LINETOSCR_SKIP_SEGMENT
//         }
      }
#else
      /* OCS/ECS Dual playfield  */
      int *lookup = bpldualpfpri ? dblpf_ind2 : dblpf_ind1;
      while (dpix < stoppos) {
//         if ((changes & 1) | do_redraw) {
            int pixcol = pixdata.apixels[spix];
            TYPE d = colors_for_drawing.acolors[lookup[pixcol]];
            spix += SRC_INC;
            buf[dpix++] = d;
#if HDOUBLE
            buf[dpix++] = d;
#endif
//            LINETOSCR_NEXT_PIXEL
//         } else {
//            LINETOSCR_SKIP_SEGMENT
//         }
      }
#endif
   } else if (bplehb) {
      while (dpix < stoppos) {
//         if ((changes & 1) | do_redraw) {
            int p = pixdata.apixels[spix];
            TYPE d = colors_for_drawing.acolors[p];
            spix += SRC_INC;
#if AGA
            /* AGA EHB playfield */
            if (p>= 32 && p < 64) /* FIXME: what about sprite colors between 32 and 64? */
               d = (colors_for_drawing.color_regs_aga[(p-32)^xor_val] >> 1) & 0x7F7F7F;
#else
            /* OCS/ECS EHB playfield */
            if (p >= 32)
               d = xcolors[(colors_for_drawing.color_uae_regs_ecs[p-32] >> 1) & 0x777];
#endif
            buf[dpix++] = d;
#if HDOUBLE
            buf[dpix++] = d;
#endif
//            LINETOSCR_NEXT_PIXEL
//         } else {
//            LINETOSCR_SKIP_SEGMENT
//         }
      }
   } else {
      while (dpix < stoppos) {
//         if ((changes & 1) | do_redraw) {
#if AGA
            TYPE d = colors_for_drawing.acolors[pixdata.apixels[spix]^xor_val];
#else
            TYPE d = colors_for_drawing.acolors[pixdata.apixels[spix]];
#endif
            spix += SRC_INC;
            buf[dpix++] = d;
#if HDOUBLE
            buf[dpix++] = d;
#endif
//            LINETOSCR_NEXT_PIXEL
//         } else {
//            LINETOSCR_SKIP_SEGMENT
//         }
      }
   }
   return spix;
}

#undef LNAME
#undef HDOUBLE
#undef SRC_INC
#undef AGA
